(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@yukawa/chain-base-angular-domain'), require('@yukawa/chain-main-angular-core'), require('@angular/core'), require('@angular/common/http'), require('rxjs/operators'), require('@yukawa/chain-base-angular-client'), require('@angular/forms'), require('@angular/common'), require('@angular/flex-layout'), require('@ngx-translate/core'), require('@angular/material/button'), require('@angular/material/icon'), require('@angular/material/core'), require('@angular/material/slide-toggle'), require('@angular/material/table'), require('@angular/material/sort'), require('@angular/material/tooltip'), require('@angular/material/menu'), require('@angular/material/checkbox')) :
    typeof define === 'function' && define.amd ? define('@yukawa/chain-tracker-angular-core', ['exports', '@yukawa/chain-base-angular-domain', '@yukawa/chain-main-angular-core', '@angular/core', '@angular/common/http', 'rxjs/operators', '@yukawa/chain-base-angular-client', '@angular/forms', '@angular/common', '@angular/flex-layout', '@ngx-translate/core', '@angular/material/button', '@angular/material/icon', '@angular/material/core', '@angular/material/slide-toggle', '@angular/material/table', '@angular/material/sort', '@angular/material/tooltip', '@angular/material/menu', '@angular/material/checkbox'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.yukawa = global.yukawa || {}, global.yukawa["chain-tracker-angular-core"] = {}), global.chainBaseAngularDomain, global.chainMainAngularCore, global.ng.core, global.ng.common.http, global.rxjs.operators, global.i2, global.ng.forms, global.ng.common, global.ng.flexLayout, global.i1$1, global.ng.material.button, global.ng.material.icon, global.ng.material.core, global.ng.material.slideToggle, global.ng.material.table, global.ng.material.sort, global.ng.material.tooltip, global.ng.material.menu, global.ng.material.checkbox));
})(this, (function (exports, chainBaseAngularDomain, chainMainAngularCore, i0, i1, operators, i2, forms, common, flexLayout, i1$1, button, icon, core, slideToggle, table, sort, tooltip, menu, checkbox) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);
    var i2__namespace = /*#__PURE__*/_interopNamespace(i2);
    var i1__namespace$1 = /*#__PURE__*/_interopNamespace(i1$1);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    function __createBinding(o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    }
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                exports[p] = m[p];
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    result[k] = mod[k];
        result.default = mod;
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    // noinspection JSUnusedGlobalSymbols
    /**
     * inc.yukawa.tracker.base.core.realm.TrackerRealm
     * @since 2.0.7
     **/
    var TrackerRealm = /** @class */ (function (_super) {
        __extends(TrackerRealm, _super);
        function TrackerRealm() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return TrackerRealm;
    }(chainMainAngularCore.MainRealm));
    TrackerRealm.ROLE_TRACKER_ADMIN = "ROLE_TRACKER_ADMIN";
    TrackerRealm.ROLE_TRACKER_EDITOR = "ROLE_TRACKER_EDITOR";
    TrackerRealm.ROLE_TRACKER_READER = "ROLE_TRACKER_READER";
    TrackerRealm.ROLE_ATTACHMENT_EDITOR = "ROLE_ATTACHMENT_EDITOR";
    TrackerRealm.ROLE_ATTACHMENT_READER = "ROLE_ATTACHMENT_READER";
    TrackerRealm.ROLE_COMMENT_EDITOR = "ROLE_COMMENT_EDITOR";
    TrackerRealm.ROLE_COMMENT_READER = "ROLE_COMMENT_READER";
    TrackerRealm.ROLE_CONTACTLOG_EDITOR = "ROLE_CONTACTLOG_EDITOR";
    TrackerRealm.ROLE_CONTACTLOG_READER = "ROLE_CONTACTLOG_READER";
    TrackerRealm.ROLE_PROJECT_EDITOR = "ROLE_PROJECT_EDITOR";
    TrackerRealm.ROLE_PROJECT_READER = "ROLE_PROJECT_READER";
    TrackerRealm.ROLE_PROJECT_TEMPLATE_EDITOR = "ROLE_PROJECT_TEMPLATE_EDITOR";
    TrackerRealm.ROLE_PROJECT_TEMPLATE_READER = "ROLE_PROJECT_TEMPLATE_READER";
    TrackerRealm.ROLE_TASK_EDITOR = "ROLE_TASK_EDITOR";
    TrackerRealm.ROLE_TASK_READER = "ROLE_TASK_READER";
    TrackerRealm.ROLE_RISK_EDITOR = "ROLE_RISK_EDITOR";
    TrackerRealm.ROLE_RISK_READER = "ROLE_RISK_READER";
    TrackerRealm.ADMINS = [chainBaseAngularDomain.BaseRealm.ROLE_ADMIN, TrackerRealm.ROLE_TRACKER_ADMIN];
    TrackerRealm.EDITORS = __spread(TrackerRealm.ADMINS, [TrackerRealm.ROLE_TRACKER_EDITOR]);
    TrackerRealm.READERS = __spread(TrackerRealm.EDITORS, [TrackerRealm.ROLE_TRACKER_READER]);
    TrackerRealm.PROJECT_READERS = __spread(TrackerRealm.READERS, [TrackerRealm.ROLE_PROJECT_READER]);
    TrackerRealm.PROJECT_EDITORS = __spread(TrackerRealm.EDITORS, [TrackerRealm.ROLE_PROJECT_EDITOR]);
    TrackerRealm.LABEL_EDITORS = __spread(TrackerRealm.EDITORS, [TrackerRealm.ROLE_LABEL_ADMIN, TrackerRealm.ROLE_LABEL_EDIT]);
    TrackerRealm.LABEL_READERS = __spread(TrackerRealm.READERS, [TrackerRealm.ROLE_LABEL_READ]);

    exports.ProjectPhase = void 0;
    (function (ProjectPhase) {
        ProjectPhase["PHASE_PROJECT"] = "project";
        ProjectPhase["PHASE_LEAD"] = "lead";
        ProjectPhase["PHASE_PROPOSAL"] = "proposal";
    })(exports.ProjectPhase || (exports.ProjectPhase = {}));
    exports.Fep = void 0;
    (function (Fep) {
        Fep["NEW"] = "NEW";
        Fep["REJECTED"] = "REJECTED";
        Fep["WAIT_FOR_CONFIRM"] = "WAIT_FOR_CONFIRM";
        Fep["CONFIRMED"] = "CONFIRMED";
    })(exports.Fep || (exports.Fep = {}));
    exports.AttachmentCategory = void 0;
    (function (AttachmentCategory) {
        AttachmentCategory["INVOICE"] = "INVOICE";
    })(exports.AttachmentCategory || (exports.AttachmentCategory = {}));
    var projectPhases = [];
    for (var n in exports.ProjectPhase) {
        if (typeof exports.ProjectPhase[n] === 'string') {
            projectPhases.push(exports.ProjectPhase[n]);
        }
    }
    var Yukawa_LeanRealm = /** @class */ (function (_super) {
        __extends(Yukawa_LeanRealm, _super);
        function Yukawa_LeanRealm() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return Yukawa_LeanRealm;
    }(TrackerRealm));
    Yukawa_LeanRealm.ROLE_INVOICE_FEP_CONFIRM_PARTIAL = "ROLE_INVOICE_FEP_CONFIRM_PARTIAL";
    Yukawa_LeanRealm.ROLE_INVOICE_FEP_REJECT = "ROLE_INVOICE_FEP_REJECT";
    Yukawa_LeanRealm.ROLE_INVOICE_FEP_CONFIRM = "ROLE_INVOICE_FEP_CONFIRM";

    var TaskUtils = /** @class */ (function () {
        function TaskUtils() {
        }
        /**
         * This function calculates the price/volume of a list of tasks
         *
         * @param subTasks List of tasks
         * @param projectRoles List of project roles containing the prices
         */
        TaskUtils.calculatePrice = function (subTasks, projectRoles) {
            var e_1, _a;
            var result = 0;
            try {
                for (var subTasks_1 = __values(subTasks), subTasks_1_1 = subTasks_1.next(); !subTasks_1_1.done; subTasks_1_1 = subTasks_1.next()) {
                    var task = subTasks_1_1.value;
                    var hourlyRate = task.role.hourlyRate;
                    var frequency = task.plannedBudget.amount;
                    if (hourlyRate && frequency) {
                        result += hourlyRate * frequency;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (subTasks_1_1 && !subTasks_1_1.done && (_a = subTasks_1.return)) _a.call(subTasks_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return result;
        };
        TaskUtils.getProjectRoleHourlyRateMap = function (roles) {
            var e_2, _a;
            var dict = {};
            try {
                for (var roles_1 = __values(roles), roles_1_1 = roles_1.next(); !roles_1_1.done; roles_1_1 = roles_1.next()) {
                    var role = roles_1_1.value;
                    dict[role.roleId] = role.hourlyRate;
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (roles_1_1 && !roles_1_1.done && (_a = roles_1.return)) _a.call(roles_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return dict;
        };
        return TaskUtils;
    }());

    var ProjectService = /** @class */ (function (_super) {
        __extends(ProjectService, _super);
        function ProjectService(http, configService) {
            return _super.call(this, http, configService, configService.formatUrl("projectUrl")) || this;
        }
        // searchProject(filter: any): Observable<SearchResult<Project>> {
        //     return this.search<Project>(this.formatServiceUrl('/search'), filter);
        // }
        ProjectService.prototype.queryProject = function (filter) {
            return this.query(this.formatServiceUrl('/query'), filter);
        };
        ProjectService.prototype.loadProject = function (id) {
            var _this = this;
            return this.load(this.formatServiceUrl('') + "?key=" + id)
                .pipe(operators.map(function (value) { return _this.checkNotNull(value); }));
        };
        ProjectService.prototype.saveProject = function (project, type) {
            if (type === void 0) { type = "create"; }
            return this.edit(this.formatServiceUrl("/" + type), project, { method: 'post' });
        };
        ProjectService.prototype.deleteProject = function (id) {
            return this.http.delete(this.formatServiceUrl('') + "?key=" + id);
        };
        ProjectService.prototype.updateProjectPhase = function (phase, projectId) {
            return this.http.post(this.formatServiceUrl('/phase') + "?projectId=" + projectId, phase);
        };
        ProjectService.prototype.newProject = function () {
            var _this = this;
            return this.http.post("" + this.formatServiceUrl('/new'), {})
                .pipe(operators.map(function (value) { return _this.checkNotNull(value); }));
        };
        ProjectService.prototype.downloadPdf = function (projectId) {
            return this.http.post("" + this.formatServiceUrl('/generateProposal'), projectId);
        };
        ProjectService.prototype.mergeProject = function (project) {
            return this.http.post(this.formatServiceUrl('/merge'), project);
        };
        ProjectService.prototype.update = function (project) {
            return this.http.post(this.formatServiceUrl('/update'), project);
        };
        ProjectService.prototype.put = function (project) {
            return this.http.post(this.formatServiceUrl('/put'), project);
        };
        ProjectService.prototype.collectionPut = function (project) {
            return this.http.post(this.formatServiceUrl('/collection/put'), project);
        };
        ProjectService.prototype.collectionRemove = function (project) {
            return this.http.post(this.formatServiceUrl('/collection/remove'), project);
        };
        ProjectService.prototype.collectionsAppend = function (project) {
            return this.http.post(this.formatServiceUrl('/collections/append'), project);
        };
        ProjectService.prototype.export = function (filter) {
            var opts = {
                headers: new i1.HttpHeaders({
                    'Content-Type': 'application/json'
                    //'Accept': 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'
                })
            };
            return this.download("" + this.formatServiceUrl('/export'), filter, opts);
        };
        return ProjectService;
    }(i2.RestAspect));
    /** @nocollapse */ ProjectService.ɵfac = function ProjectService_Factory(t) { return new (t || ProjectService)(i0__namespace.ɵɵinject(i0.forwardRef(function () { return i1.HttpClient; })), i0__namespace.ɵɵinject(i0.forwardRef(function () { return i2.ConfigService; }))); };
    /** @nocollapse */ ProjectService.ɵprov = i0__namespace.ɵɵdefineInjectable({ token: ProjectService, factory: ProjectService.ɵfac });
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(ProjectService, [{
                type: i0.Injectable
            }], function () {
            return [{ type: i1__namespace.HttpClient, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i1.HttpClient; })]
                        }] }, { type: i2__namespace.ConfigService, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i2.ConfigService; })]
                        }] }];
        }, null);
    })();
    var TaskService = /** @class */ (function (_super) {
        __extends(TaskService, _super);
        function TaskService(http, configService) {
            return _super.call(this, http, configService, configService.formatUrl("taskUrl")) || this;
        }
        // searchTask(filter: any): Observable<SearchResult<Task>> {
        //     return this.search<Project>(this.formatServiceUrl('/search'), filter);
        // }
        TaskService.prototype.queryTask = function (filter) {
            return this.query(this.formatServiceUrl('/query'), filter);
        };
        TaskService.prototype.loadTask = function (id) {
            var _this = this;
            return this.load(this.formatServiceUrl('') + "?key=" + id)
                .pipe(operators.map(function (value) { return _this.checkNotNull(value); }));
        };
        TaskService.prototype.saveTask = function (task, type) {
            if (type === void 0) { type = "create"; }
            return this.edit(this.formatServiceUrl("/" + type), task, { method: 'post' });
        };
        TaskService.prototype.mergeTask = function (task) {
            return this.edit(this.formatServiceUrl("/merge"), task, { method: 'post' });
        };
        TaskService.prototype.deleteTask = function (id) {
            return this.http.delete(this.formatServiceUrl() + "/?key=" + id);
        };
        TaskService.prototype.generateInvoice = function (invoice) {
            return this.http.post(this.formatServiceUrl('/generateInvoice'), invoice);
        };
        return TaskService;
    }(i2.RestAspect));
    /** @nocollapse */ TaskService.ɵfac = function TaskService_Factory(t) { return new (t || TaskService)(i0__namespace.ɵɵinject(i0.forwardRef(function () { return i1.HttpClient; })), i0__namespace.ɵɵinject(i0.forwardRef(function () { return i2.ConfigService; }))); };
    /** @nocollapse */ TaskService.ɵprov = i0__namespace.ɵɵdefineInjectable({ token: TaskService, factory: TaskService.ɵfac, providedIn: 'root' });
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(TaskService, [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], function () {
            return [{ type: i1__namespace.HttpClient, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i1.HttpClient; })]
                        }] }, { type: i2__namespace.ConfigService, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i2.ConfigService; })]
                        }] }];
        }, null);
    })();
    var ProjectSheetService = /** @class */ (function (_super) {
        __extends(ProjectSheetService, _super);
        function ProjectSheetService(http, configService) {
            return _super.call(this, http, configService, configService.formatUrl("projectSheetUrl")) || this;
        }
        // searchProjectSheet(filter: any): Observable<SearchResult<ProjectSheet>> {
        //     return this.search<ProjectSheet>(this.formatServiceUrl('/search'), filter);
        // }
        ProjectSheetService.prototype.queryProjectSheet = function (filter) {
            return this.query(this.formatServiceUrl('/query'), filter);
        };
        ProjectSheetService.prototype.loadProjectSheet = function (id) {
            var _this = this;
            return this.load(this.formatServiceUrl('') + "/?key=" + id)
                .pipe(operators.map(function (value) { return _this.checkNotNull(value); }));
        };
        ProjectSheetService.prototype.saveProjectSheet = function (task, type) {
            if (type === void 0) { type = "create"; }
            return this.edit(this.formatServiceUrl("/" + type), task, { method: 'post' });
        };
        ProjectSheetService.prototype.deleteProjectSheet = function (id) {
            return this.http.delete(this.formatServiceUrl() + "/?key=" + id);
        };
        return ProjectSheetService;
    }(i2.RestAspect));
    /** @nocollapse */ ProjectSheetService.ɵfac = function ProjectSheetService_Factory(t) { return new (t || ProjectSheetService)(i0__namespace.ɵɵinject(i0.forwardRef(function () { return i1.HttpClient; })), i0__namespace.ɵɵinject(i0.forwardRef(function () { return i2.ConfigService; }))); };
    /** @nocollapse */ ProjectSheetService.ɵprov = i0__namespace.ɵɵdefineInjectable({ token: ProjectSheetService, factory: ProjectSheetService.ɵfac });
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(ProjectSheetService, [{
                type: i0.Injectable
            }], function () {
            return [{ type: i1__namespace.HttpClient, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i1.HttpClient; })]
                        }] }, { type: i2__namespace.ConfigService, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i2.ConfigService; })]
                        }] }];
        }, null);
    })();
    var RiskService = /** @class */ (function (_super) {
        __extends(RiskService, _super);
        function RiskService(http, configService) {
            return _super.call(this, http, configService, configService.formatUrl("risksUrl")) || this;
        }
        RiskService.prototype.searchRisk = function (filter) {
            return this.search(this.formatServiceUrl('/search'), filter);
        };
        RiskService.prototype.queryRisks = function (filter) {
            return this.query(this.formatServiceUrl('/query'), filter);
        };
        RiskService.prototype.loadRisk = function (id) {
            var _this = this;
            return this.load(this.formatServiceUrl('') + "/?key=" + id)
                .pipe(operators.map(function (value) { return _this.checkNotNull(value); }));
        };
        RiskService.prototype.saveRisk = function (task, type) {
            if (type === void 0) { type = "create"; }
            return this.edit(this.formatServiceUrl("/" + type), task, { method: 'post' });
        };
        RiskService.prototype.deleteRisk = function (id) {
            return this.http.delete(this.formatServiceUrl() + "/?key=" + id);
        };
        return RiskService;
    }(i2.RestAspect));
    /** @nocollapse */ RiskService.ɵfac = function RiskService_Factory(t) { return new (t || RiskService)(i0__namespace.ɵɵinject(i0.forwardRef(function () { return i1.HttpClient; })), i0__namespace.ɵɵinject(i0.forwardRef(function () { return i2.ConfigService; }))); };
    /** @nocollapse */ RiskService.ɵprov = i0__namespace.ɵɵdefineInjectable({ token: RiskService, factory: RiskService.ɵfac, providedIn: 'root' });
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(RiskService, [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], function () {
            return [{ type: i1__namespace.HttpClient, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i1.HttpClient; })]
                        }] }, { type: i2__namespace.ConfigService, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i2.ConfigService; })]
                        }] }];
        }, null);
    })();

    var AttachmentService = /** @class */ (function (_super) {
        __extends(AttachmentService, _super);
        function AttachmentService(http, configService) {
            return _super.call(this, http, configService, 'attachmentUrl') || this;
        }
        AttachmentService.prototype.download = function (id, version) {
            return this.http.get(this.formatServiceUrl('/download/' + id), {
                responseType: 'blob'
            });
        };
        AttachmentService.prototype.upload = function (attachment) {
            // @toDo * [ww] impl
            throw new Error('upload not implemented');
        };
        AttachmentService.prototype.confirmAttachment = function (id) {
            return this.http.post(this.formatServiceUrl() + "/fep/confirm?attachmentId=" + id, null);
        };
        AttachmentService.prototype.rejectAttachment = function (id) {
            return this.http.post(this.formatServiceUrl() + "/fep/reject?attachmentId=" + id, null);
        };
        // @toDo remove later
        AttachmentService.prototype.deleteByKey = function (key) {
            var e_1, _a;
            // overloaded for this.formatServiceUrl('/')
            var queryParamsList = [];
            if (key !== undefined && key !== null) {
                queryParamsList.push({ name: 'key', value: key.toString() });
            }
            var params = new i1.HttpParams();
            try {
                for (var queryParamsList_1 = __values(queryParamsList), queryParamsList_1_1 = queryParamsList_1.next(); !queryParamsList_1_1.done; queryParamsList_1_1 = queryParamsList_1.next()) {
                    var queryParam = queryParamsList_1_1.value;
                    params = params.append(queryParam.name, queryParam.value);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (queryParamsList_1_1 && !queryParamsList_1_1.done && (_a = queryParamsList_1.return)) _a.call(queryParamsList_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return this.http.delete(this.formatServiceUrl('/'), { params: params });
        };
        return AttachmentService;
    }(i2.RepoAspectRest));
    /** @nocollapse */ AttachmentService.ɵfac = function AttachmentService_Factory(t) { return new (t || AttachmentService)(i0__namespace.ɵɵinject(i0.forwardRef(function () { return i1.HttpClient; })), i0__namespace.ɵɵinject(i0.forwardRef(function () { return i2.ConfigService; }))); };
    /** @nocollapse */ AttachmentService.ɵprov = i0__namespace.ɵɵdefineInjectable({ token: AttachmentService, factory: AttachmentService.ɵfac, providedIn: "root" });
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(AttachmentService, [{
                type: i0.Injectable,
                args: [{ providedIn: "root" }]
            }], function () {
            return [{ type: i1__namespace.HttpClient, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i1.HttpClient; })]
                        }] }, { type: i2__namespace.ConfigService, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i2.ConfigService; })]
                        }] }];
        }, null);
    })();

    var PROJECT_ASPECT = new i0.InjectionToken("Project aspect token");

    var ORG_ID = new i0.InjectionToken("injection token for the org id of the logged in user");
    var PARTNERS = new i0.InjectionToken("");
    var partnersQueryObservableFactory = function (partnerService) {
        return partnerService.query({ pager: { firstResult: 0, pageSize: 10000 } }).pipe(operators.map(function (res) { return res.items; }));
    };

    var DbtgProjectService = /** @class */ (function (_super) {
        __extends(DbtgProjectService, _super);
        function DbtgProjectService(http, configService) {
            var _this = _super.call(this, http, configService, "projectUrl") || this;
            _this.http = http;
            _this.configService = configService;
            return _this;
        }
        DbtgProjectService.prototype.beforeRead = function (filter) {
            return _super.prototype.beforeRead.call(this, filter);
        };
        DbtgProjectService.prototype.afterQuery = function (result) {
            return _super.prototype.afterQuery.call(this, result);
        };
        return DbtgProjectService;
    }(i2.InterceptedRepoAspectsRest));

    var DefaultProjectService = /** @class */ (function (_super) {
        __extends(DefaultProjectService, _super);
        function DefaultProjectService(http, configService) {
            var _this = _super.call(this, http, configService, "projectUrl") || this;
            _this.http = http;
            _this.configService = configService;
            return _this;
        }
        return DefaultProjectService;
    }(i2.InterceptedRepoAspectsRest));

    function projectAspectFactory() {
        var orgId = i0.inject(ORG_ID);
        var configService = i0.inject(i2.ConfigService);
        var httpClient = i0.inject(i1.HttpClient);
        if (orgId.value === "dbtg") {
            return new DbtgProjectService(httpClient, configService);
        }
        else {
            return new DefaultProjectService(httpClient, configService);
        }
    }

    // services
    var CoreModule = /** @class */ (function () {
        function CoreModule() {
        }
        CoreModule.forRoot = function () {
            return {
                ngModule: CoreModule,
                providers: [
                    {
                        provide: PROJECT_ASPECT,
                        useFactory: projectAspectFactory,
                        deps: [i2.ConfigService, i1.HttpClient, ORG_ID]
                    },
                    ProjectService,
                    ProjectSheetService,
                    TaskService,
                    AttachmentService,
                    RiskService
                ]
            };
        };
        return CoreModule;
    }());
    /** @nocollapse */ CoreModule.ɵmod = i0__namespace.ɵɵdefineNgModule({ type: CoreModule });
    /** @nocollapse */ CoreModule.ɵinj = i0__namespace.ɵɵdefineInjector({ factory: function CoreModule_Factory(t) { return new (t || CoreModule)(); }, providers: [], imports: [[
                common.CommonModule,
                forms.FormsModule,
                button.MatButtonModule,
                icon.MatIconModule,
                core.MatRippleModule,
                slideToggle.MatSlideToggleModule,
                table.MatTableModule,
                sort.MatSortModule,
                tooltip.MatTooltipModule,
                flexLayout.FlexLayoutModule,
                menu.MatMenuModule,
                checkbox.MatCheckboxModule,
                i1.HttpClientModule,
                i1$1.TranslateModule.forChild()
            ]] });
    (function () {
        (typeof ngJitMode === "undefined" || ngJitMode) && i0__namespace.ɵɵsetNgModuleScope(CoreModule, { imports: [common.CommonModule,
                forms.FormsModule,
                button.MatButtonModule,
                icon.MatIconModule,
                core.MatRippleModule,
                slideToggle.MatSlideToggleModule,
                table.MatTableModule,
                sort.MatSortModule,
                tooltip.MatTooltipModule,
                flexLayout.FlexLayoutModule,
                menu.MatMenuModule,
                checkbox.MatCheckboxModule,
                i1.HttpClientModule, i1__namespace$1.TranslateModule] });
    })();
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(CoreModule, [{
                type: i0.NgModule,
                args: [{
                        imports: [
                            common.CommonModule,
                            forms.FormsModule,
                            button.MatButtonModule,
                            icon.MatIconModule,
                            core.MatRippleModule,
                            slideToggle.MatSlideToggleModule,
                            table.MatTableModule,
                            sort.MatSortModule,
                            tooltip.MatTooltipModule,
                            flexLayout.FlexLayoutModule,
                            menu.MatMenuModule,
                            checkbox.MatCheckboxModule,
                            i1.HttpClientModule,
                            i1$1.TranslateModule.forChild()
                        ],
                        declarations: [],
                        exports: [],
                        providers: [],
                        entryComponents: [],
                        schemas: [i0.CUSTOM_ELEMENTS_SCHEMA]
                    }]
            }], null, null);
    })();

    var CachedPartnerService = /** @class */ (function (_super) {
        __extends(CachedPartnerService, _super);
        function CachedPartnerService(http, configService) {
            return _super.call(this, http, configService, "partnerUrl", function (partner) { return partner.partnerId; }) || this;
        }
        return CachedPartnerService;
    }(i2.CachedRepoAspectRest));
    /** @nocollapse */ CachedPartnerService.ɵfac = function CachedPartnerService_Factory(t) { return new (t || CachedPartnerService)(i0__namespace.ɵɵinject(i1__namespace.HttpClient), i0__namespace.ɵɵinject(i2__namespace.ConfigService)); };
    /** @nocollapse */ CachedPartnerService.ɵprov = i0__namespace.ɵɵdefineInjectable({ token: CachedPartnerService, factory: CachedPartnerService.ɵfac, providedIn: "root" });
    /*@__PURE__*/ (function () {
        i0__namespace.ɵsetClassMetadata(CachedPartnerService, [{
                type: i0.Injectable,
                args: [{
                        providedIn: "root"
                    }]
            }], function () { return [{ type: i1__namespace.HttpClient }, { type: i2__namespace.ConfigService }]; }, null);
    })();

    var CustomFieldIds = /** @class */ (function () {
        function CustomFieldIds() {
        }
        return CustomFieldIds;
    }());
    CustomFieldIds.FUNDING_REQUEST_SUBMITTED = "FUNDING_REQUEST_SUBMITTED";
    CustomFieldIds.FUNDING_PROGRAM = "FUNDING_PROGRAM";
    CustomFieldIds.ZUW_BESCHEID = "ZUW_BESCHEID";
    CustomFieldIds.APPLICATION_AMOUNT = "APPLICATION_AMOUNT";
    CustomFieldIds.ASSOCIATION_FEE_PERCENT = "ASSOCIATION_FEE_PERCENT";
    CustomFieldIds.ASSOCIATION_FEE_EURO = "ASSOCIATION_FEE_EURO";
    CustomFieldIds.PLANNING_ORDER = "PLANNING_ORDER";
    CustomFieldIds.PROJECT_STATUS = "PROJECT_STATUS";
    CustomFieldIds.PROJECT_CATEGORY = "PROJECT_CATEGORY";
    CustomFieldIds.SALES_PRODUCT = "SALES_PRODUCT";
    CustomFieldIds.PLANNED_REALIZATION = "PLANNED_REALIZATION";
    CustomFieldIds.PROJECT_PROVISION_PERCENT = "PROJECT_PROVISION_PERCENT";
    CustomFieldIds.PROJECT_PROVISION_EURO = "PROJECT_PROVISION_EURO";
    CustomFieldIds.NEXT_APPOINTMENT = "NEXT_APPOINTMENT";
    CustomFieldIds.PROBABILITY = "PROBABILITY";
    CustomFieldIds.EXPECTED_COMMISSIONING = "EXPECTED_COMMISSIONING";
    CustomFieldIds.NUMBER_OF_FLOODLIGHTS = "NUMBER_OF_FLOODLIGHTS";
    CustomFieldIds.NUMBER_OF_CHARGING_POINTS = "NUMBER_OF_CHARGING_POINTS";
    CustomFieldIds.E_MOBILITY_SALES_PRODUCT_MAINTENANCE = "E_MOBILITY_SALES_PRODUCT_MAINTENANCE";
    CustomFieldIds.E_MOBILITY_SALES_PRODUCT_DISTRIBUTION = "E_MOBILITY_SALES_PRODUCT_DISTRIBUTION";
    CustomFieldIds.E_MOBILITY_SALES_PRODUCT_PLANNING_ORDER = "E_MOBILITY_SALES_PRODUCT_PLANNING_ORDER";
    CustomFieldIds.E_MOBILITY_SALES_PRODUCT_BACKEND = "E_MOBILITY_SALES_PRODUCT_BACKEND";
    CustomFieldIds.E_MOBILITY_SALES_PRODUCT_COMMERCE = "E_MOBILITY_SALES_PRODUCT_COMMERCE";
    CustomFieldIds.E_MOBILITY_SALES_PRODUCT_INSTALLER = "E_MOBILITY_SALES_PRODUCT_INSTALLER";
    CustomFieldIds.E_MOBILITY_SALES_PRODUCT_INVESTOR_MODEL = "E_MOBILITY_SALES_PRODUCT_INVESTOR_MODEL";

    exports.ProjectCategory = void 0;
    (function (ProjectCategory) {
        ProjectCategory["E_MOBILITY"] = "Elektromobilit\u00E4t";
        ProjectCategory["PHOTOVOLTAIC"] = "Photovoltaik";
        ProjectCategory["LED"] = "LED";
    })(exports.ProjectCategory || (exports.ProjectCategory = {}));

    exports.ProjectStatus = void 0;
    (function (ProjectStatus) {
        ProjectStatus["FIRST_CONTACT"] = "Erstkontakt erfolgt";
        ProjectStatus["OFFER_IN_PROGRESS"] = "Angebot in Arbeit";
        ProjectStatus["FOLLOW_UP_ACQUISITION"] = "Nachakquise";
        ProjectStatus["OFFER_SENT"] = "Angebot versendet";
        ProjectStatus["REVISE_OFFER"] = "Angebot \u00FCberarbeiten";
        ProjectStatus["ORDER_CONFIRMATION_RECEIVED"] = "Auftragsbest\u00E4tigung erhalten";
        ProjectStatus["PREPAYMENT_RECEIVED"] = "Anzahlung erhalten";
        ProjectStatus["ORDER_RECIEVED"] = "Auftrag erhalten";
        ProjectStatus["FINAL_INVOICE"] = "Schlussrechnung gestellt";
    })(exports.ProjectStatus || (exports.ProjectStatus = {}));

    // Managers

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AttachmentService = AttachmentService;
    exports.CachedPartnerService = CachedPartnerService;
    exports.CoreModule = CoreModule;
    exports.CustomFieldIds = CustomFieldIds;
    exports.ORG_ID = ORG_ID;
    exports.PARTNERS = PARTNERS;
    exports.PROJECT_ASPECT = PROJECT_ASPECT;
    exports.ProjectService = ProjectService;
    exports.ProjectSheetService = ProjectSheetService;
    exports.RiskService = RiskService;
    exports.TaskService = TaskService;
    exports.TaskUtils = TaskUtils;
    exports.TrackerRealm = TrackerRealm;
    exports.Yukawa_LeanRealm = Yukawa_LeanRealm;
    exports.partnersQueryObservableFactory = partnersQueryObservableFactory;
    exports.projectAspectFactory = projectAspectFactory;
    exports.projectPhases = projectPhases;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=yukawa-chain-tracker-angular-core.umd.js.map
