import { TaskFilter } from "../../../gen/filter";
import { TrackerRealm } from "../../../ts/realm";
export declare enum ProjectPhase {
    PHASE_PROJECT = "project",
    PHASE_LEAD = "lead",
    PHASE_PROPOSAL = "proposal"
}
export declare enum Fep {
    NEW = "NEW",
    REJECTED = "REJECTED",
    WAIT_FOR_CONFIRM = "WAIT_FOR_CONFIRM",
    CONFIRMED = "CONFIRMED"
}
export declare enum AttachmentCategory {
    INVOICE = "INVOICE"
}
export declare const projectPhases: {
    id: number;
    name: string;
}[];
export interface InvoiceInfo {
    additionalComments?: string;
    taskFilter?: TaskFilter;
}
export declare class Yukawa_LeanRealm extends TrackerRealm {
    static readonly ROLE_INVOICE_FEP_CONFIRM_PARTIAL = "ROLE_INVOICE_FEP_CONFIRM_PARTIAL";
    static readonly ROLE_INVOICE_FEP_REJECT = "ROLE_INVOICE_FEP_REJECT";
    static readonly ROLE_INVOICE_FEP_CONFIRM = "ROLE_INVOICE_FEP_CONFIRM";
}
