import { ConfigService, RepoAspectRest } from "@yukawa/chain-base-angular-client";
import { HttpClient } from "@angular/common/http";
import { Observable } from "rxjs";
import { AttachmentAspect } from "../../../ts/aspect";
import { Attachment } from "../../../gen/domain";
import { AttachmentFilter } from "../../../gen/filter";
import * as i0 from "@angular/core";
export declare class AttachmentService extends RepoAspectRest<string, Attachment, AttachmentFilter> implements AttachmentAspect {
    constructor(http: HttpClient, configService: ConfigService);
    download(id: string, version?: string): Observable<Blob>;
    upload(attachment: Attachment): Observable<any>;
    confirmAttachment(id: string): Observable<Attachment>;
    rejectAttachment(id: string): Observable<Attachment>;
    deleteByKey(key: String): Observable<Attachment>;
    static ɵfac: i0.ɵɵFactoryDef<AttachmentService, never>;
    static ɵprov: i0.ɵɵInjectableDef<AttachmentService>;
}
