import { InjectionToken } from "@angular/core";
import { BehaviorSubject, Observable } from "rxjs";
import { Partner } from "@yukawa/chain-crm-angular-core";
import { CachedPartnerService } from "./crm/cached-partner.service";
export declare const ORG_ID: InjectionToken<BehaviorSubject<string>>;
export declare const PARTNERS: InjectionToken<Observable<Partner[]>>;
export declare const partnersQueryObservableFactory: (partnerService: CachedPartnerService) => Observable<Partner[]>;
