import { MainRealm } from "@yukawa/chain-main-angular-core";
/**
 * inc.yukawa.tracker.base.core.realm.TrackerRealm
 * @since 2.0.7
 **/
export declare class TrackerRealm extends MainRealm {
    static readonly ROLE_TRACKER_ADMIN = "ROLE_TRACKER_ADMIN";
    static readonly ROLE_TRACKER_EDITOR = "ROLE_TRACKER_EDITOR";
    static readonly ROLE_TRACKER_READER = "ROLE_TRACKER_READER";
    static readonly ROLE_ATTACHMENT_EDITOR = "ROLE_ATTACHMENT_EDITOR";
    static readonly ROLE_ATTACHMENT_READER = "ROLE_ATTACHMENT_READER";
    static readonly ROLE_COMMENT_EDITOR = "ROLE_COMMENT_EDITOR";
    static readonly ROLE_COMMENT_READER = "ROLE_COMMENT_READER";
    static readonly ROLE_CONTACTLOG_EDITOR = "ROLE_CONTACTLOG_EDITOR";
    static readonly ROLE_CONTACTLOG_READER = "ROLE_CONTACTLOG_READER";
    static readonly ROLE_PROJECT_EDITOR = "ROLE_PROJECT_EDITOR";
    static readonly ROLE_PROJECT_READER = "ROLE_PROJECT_READER";
    static readonly ROLE_PROJECT_TEMPLATE_EDITOR = "ROLE_PROJECT_TEMPLATE_EDITOR";
    static readonly ROLE_PROJECT_TEMPLATE_READER = "ROLE_PROJECT_TEMPLATE_READER";
    static readonly ROLE_TASK_EDITOR = "ROLE_TASK_EDITOR";
    static readonly ROLE_TASK_READER = "ROLE_TASK_READER";
    static readonly ROLE_RISK_EDITOR = "ROLE_RISK_EDITOR";
    static readonly ROLE_RISK_READER = "ROLE_RISK_READER";
    static readonly ADMINS: string[];
    static readonly EDITORS: string[];
    static readonly READERS: string[];
    static readonly PROJECT_READERS: string[];
    static readonly PROJECT_EDITORS: string[];
    static readonly LABEL_EDITORS: string[];
    static readonly LABEL_READERS: string[];
}
